package renzhengshouquan

import (
	"encoding/base64"

	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/icebergs/base/nfs"
	// "shylinux.com/x/icebergs/base/web"
	"shylinux.com/x/toolkits"

	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common"
	cloudprofile "github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common/profile"
	ocr "github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/ocr/v20181119"
	"shylinux.com/x/community/src/renzhengshouquan/model"
)

type cert struct {
	Table
	order  string `data:"1"`
	fields string `data:"title,content,path,user_uid"`
	upload string `name:"upload" role:"leader"`
	remove string `name:"remove" role:"leader"`
}

func (s cert) Upload(m *ice.Message, arg ...string) {
	m.WarnNotValid(!kit.IsIn(m.OptionDefault(mdb.FIELD, "cert"), "cert"))
	s.UploadCreate(m, model.PATH, m.Option(model.AUTH_UID))
}
func (s cert) List(m *ice.Message, arg ...string) {
	if len(arg) == 1 {
		s.Select(m, model.AUTH_UID, arg[0]).PushAction(s.Remove).Action(s.Upload).Display("").DisplayCSS("")
		s.Button(m, "", s.Upload)
	}

	// _msg := m.Cmd(web.CHAT_WX_OCR, "", m.Append(model.PATH), "bizlicense")
	// m.Echo(kit.Formats(_msg))
	s.BizLicenseOCR(m)
}
func (s cert) newClient(m *ice.Message, arg ...string) *ocr.Client {
	msg := m.Cmd("web.team.renzhengshouquan.external.tencentcloud.tencentcloud", "4c6a8ccf186816b332ad9dc5655255dd")
	credential := common.NewCredential(msg.Append("secret_id"), msg.Append("secret_key"))
	client, _ := ocr.NewClient(credential, "", cloudprofile.NewClientProfile())
	return client
}
func (s cert) BizLicenseOCR(m *ice.Message, arg ...string) *ice.Message {
	request := ocr.NewBizLicenseOCRRequest()
	request.ImageBase64 = common.StringPtr(base64.StdEncoding.EncodeToString([]byte(m.Cmdx(nfs.CAT, m.Append(model.PATH)))))
	response, err := s.newClient(m).BizLicenseOCR(request)
	m.Warn(err)
	m.SetAppend()
	m.PushDetail(kit.Value(kit.UnMarshal(response.ToJsonString()), "Response"))
	return m
}

func init() { ice.TeamCtxCmd(cert{}) }
